#!/usr/bin/perl -w

use strict;
use CGI;
use CGI::Carp qw(fatalsToBrowser);

# Enable or disable the Upload
my $serviceEnabled = 1;

# File size limit
my $sizeLimit = 1024 * 1; # -> 1MB
my $sizeLimitWeb = $sizeLimit * 1024;
$CGI::POST_MAX = $sizeLimitWeb;

my $cgi = new CGI;

# Disable
if($serviceEnabled == 0) {
    print $cgi->header(-type => 'text/html');
    print <<"EOT1";
<html>
<head>
<title>Fileupload disabled</title>
</head>
<body bgcolor="#FFFFFF">
<h1>This service is not available</h1>
</body>
</html>
EOT1

    exit 0;
}


if (!$cgi->param('myfile') && $cgi->cgi_error()) {
    print $cgi->header(-type => 'text/html');
    print $cgi->cgi_error();
    print <<"EOT";
<html>
<head>
<title>Fileupload Error</title>
</head>
<body bgcolor="#FFFFFF">
<h1>File is too big ($sizeLimit kB)!</h1>
</body>
</html>
EOT

    exit 0;
}

# Get file content
my $file = $cgi->param('myfile');

if(!$file) {
    print $cgi->header(-type => 'text/html');
    print <<"_HTML";
<html>
<head>
<title>Open File</title>
</head>
<h2>Max file size: $sizeLimit kBytes</h2>
<form action="https://<HOST>/cgi-bin/<SCRIPT>.pl" method="post" enctype="multipart/form-data">
<input type="file" name="myfile" accept="text/*" maxlength="$sizeLimitWeb">
<input type="submit"><input type="reset">
</form>
</html>
_HTML

    exit
}

# Replace dangerous file names
my $untainted_filename;

if ($file =~ /^([-\@:\/\\\w.]+)$/) {
            $untainted_filename = $1;
} else {
            die <<"EOT";
    Unsupported characters in the filename "$file". 
    Your filename may only contain alphabetic characters and numbers, 
    and the characters '_', '-', '\@', '/', '\\' and '.'
EOT
        }

        if ($untainted_filename =~ m/\.\./) {
            die <<"EOT";
    Your upload filename may not contain the sequence '..' 
    Rename your file so that it does not include the sequence '..', and try again.
EOT
}

# Create random file name
my $fname = 'file_'.$$.'_'.$ENV{REMOTE_ADDR}.'_'.time.'_'.$untainted_filename;
my $downloadsrc = "https://<HOST>/<UPLOAD_PATH>/$fname";

# Needed header extensions for the client
print $cgi->header(
    -type => 'text/html',
    -download_url => "$downloadsrc",
    -download_filename => "$fname",
    -download_maxsize => "$sizeLimit",
);

open DAT,'>../<SAVE_FILES_HERE>/'.$fname or die 'Error processing file: ',$!;
binmode $file;
binmode DAT;

my $data;
my $size_counter = 0;
	
print <<"HTML";
<html>
<head>
<title>Uploading File...</title>
</head>
<body bgcolor="#FFFFFF">
HTML

while(read $file,$data,1024) {
  print DAT $data;
  $size_counter++;

  if($size_counter > ($sizeLimit)) {
	print <<"HTML";
<h1>File too big ($size_counter kB)!</h1>
</body>
</html>
HTML

        # Cleanup
        close DAT;
        open DAT,'>../<SAVE_FILES_HERE>/'.$fname or die 'Error processing file: ',$!;
        print DAT "";
        close DAT;
        exit;
  }
}

close DAT;
my $filesize = $size_counter;

print <<"HTML";
<h1>File $file successfully uploaded.</h1>

<p>
Your file $file was successfully uploaded (Size: $filesize KByte).
  </p>
  <p>
  Use this URL for download: <a href="$downloadsrc">$fname</a>
  </p>
</body>
</html>
HTML
